package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataFlickerMapper;
import com.pqs9900.pojo.HisData.DataFlicker;
import com.pqs9900.service.HisData.DataFlickerService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO 短时闪变
 * @Date  2018/12/17 10:52
 **/
@Service
public class DataFlickerServiceImpl implements DataFlickerService {

    private static final Logger logger= LoggerFactory.getLogger(DataFlickerServiceImpl.class);

    @Autowired
    DataFlickerMapper dataFlickerMapper;

    @Autowired
    ThreadPoolTaskExecutor taskExecutor;

    @Override
    public int saveDataFlicker(DataFlicker dataFlicker) {
        return dataFlickerMapper.insert(dataFlicker);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataFlicker(List<DataFlicker> list) {
        return dataFlickerMapper.insertDataFlicker(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataFlicker 短时闪变数据
     */
    @Override
    public Future insertDataFlickerExecutor(List<DataFlicker> listDataFlicker) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public String call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataFlicker.size() / (double) inum);
                    List<DataFlicker> tmpListDataFlicker = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataFlicker.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataFlicker.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataFlicker.addAll(listDataFlicker.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataFlickerMapper.insertDataFlicker(tmpListDataFlicker);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("短时闪变导入异常，异常是" + e.toString());
                    return "FAIL";
                }
        }};
        return taskExecutor.submit(callable);
    }
}
